import { ref, onMounted, onUnmounted } from 'vue'
import dialogdrag from '@/hooks/useDraggle'

export default function useDraggle() {
  const hidHeader = ref(null)
  const dragStop = ref(0)
  const getDragWidth = () => {
    const screenWidth = document.body.clientWidth
    // const diffwidth = screenWidth - hidHeader.value.clientWidth - 145
    const diffwidth = screenWidth - hidHeader.value.clientWidth
    return diffwidth
  }
  function listenResizeFn() {
    dragStop.value = getDragWidth()
    const _hidHeader = hidHeader.value
    dialogdrag.bind(_hidHeader, 'x', dragStop.value)
  }

  onMounted(() => {
    listenResizeFn()
    window.addEventListener('resize', listenResizeFn)
  })

  onUnmounted(() => {
    window.removeEventListener('resize', listenResizeFn)
  })

  return { hidHeader }
}
