import request from '@/utils/request'
import qs from 'qs'

export const login = (data) => {
  return request({
    url: '/auth/custom/login',
    method: 'post',
    headers: {
      'Content-Type': 'application/x-www-form-urlencoded'
    },
    data: qs.stringify(data) // notice
  })
}

export const loginByCode = (params) => {
  return request({
    url: '/auth/custom/iam',
    method: 'get',
    params
  })
}
// 查询用户信息--zjs
export function getUserInfo(data) {
  return request({
    url: '/sys/user/getUserDetail',
    method: 'get',
  })
}
// 获取左侧用户可见菜单---zjs
export const getAuthMenuApi = (data) => {
  return request({
    method: 'post',
    url: '/sys/open/listUserResource',
    data: data,
  })
}
// 获取菜单权限按钮集合---zjs
export const getAuthBtnsApi = (data) => {
  return request({
    method: 'post',
    // url: '/sys/resource/searchResourceTree',
    url: 'sys/open/listUserResource',
    data: data,
  })
}
export const getSysRouter = (data) => {
  return request({
    // url: '/sys/resource/listIndexMenu',
    url: '/sys/resource/listUserResource',
    method: 'post',
    data: {
      sysCode: 'HID'
    },
  })
}

export const getIamSetting = (params) => {
  return request({
    url: '/sys/user/getIamConfig',
    method: 'get',
    params,
  })
}

export const getPermissionBtns = (data) => {
  return request({
    // url: '/sys/resource/listUserResource',
    // url: '/project/projectAuth/listUserResource',
    url: '/sys/resource/listUserResource',
    method: 'post',
    data: {
      menuType: 'button',
      sysCode: 'HID'
    },
  })
}
// 获取token
export const getToken = (userCode) => {
  return request({
    // url: '/sys/resource/listIndexMenu',
    url: '/auth/custom/getToken',
    method: 'post',
    data: {
      clientId: 'DCP',
      secret: '4e0216e2deaec287',
      userCode: userCode
    },
  })
}
