import request from '@/utils/request'
/**
 * 获取用户角色列表
 * @param key
 * @param params
 */
export function getUserRolelist(data) {
  return request({
    url: '/sys/role/listUserRole',
    method: 'post',
    data
  })
}
/**
 * 获取角色分页列表
 * @param key
 * @param params
 */
export function getRolelist(data) {
  return request({
    // url: '/sys/role/listByCondition',
    url: '/sys/role/selectList',
    method: 'post',
    data
  })
}
/**
 * 获取角色分配人员列表
 * @param data
 */
export function getObjectRolelist(data) {
  return request({
    url: '/sys/role/selectUserRoleRela',
    method: 'post',
    data
  })
}
/**
 * 保存 obj-role-user
 * @param data
 */
export function saveObjectRole(data) {
  return request({
    url: '/sys/role/saveUserRoleRela',
    method: 'post',
    data
  })
}
/**
 * 角色管理- 查询角色树形结构
 * @param data
 */
export function getRoleTreeList(data) {
  return request({
    url: '/sys/role/searchRoleTree',
    method: 'post',
    data
  })
}
/**
 * 角色管理- 查询角色的权限集合
 * @param data
 */
export function getRoleAuthList(data) {
  return request({
    url: '/sys/role/listRoleGroupResource',
    method: 'get',
    params: data
  })
}
/**
 * 角色管理- 新增编辑保存角色
 * @param data
 */
export function saveRole(data) {
  return request({
    url: 'sys/role/saveRole',
    method: 'post',
    data: data
  })
}
/**
 * 角色管理- 删除角色
 * @param data
 */
export function deleteRole(data) {
  return request({
    url: '/sys/role/deleteById',
    method: 'get',
    params: data
  })
}
/**
 * 角色管理- 权限比较查询多个角色的权限集合
 * @param data
 */
export function getCompareRoleAuthList(data) {
  return request({
    url: '/sys/role/selectRoleResourceRela',
    method: 'post',
    data: data
  })
}
/**
 * 角色管理- 添加人员
 * @param data
 */
export function addRoleUser(data) {
  return request({
    url: '/sys/role/addRoleUserRela',
    method: 'post',
    data: data
  })
}
/**
 * 角色管理- 启用禁用角色
 * @param data
 */
export function updateRoleStatus(data) {
  return request({
    url: '/sys/role/updateRoleStatus',
    method: 'post',
    data: data
  })
}
/**
 * 角色管理- 删除角色下的人员
 * @param data
 */
export function deleteRoleUser(data) {
  return request({
    url: '/sys/role/deleteRoleUserRela',
    method: 'post',
    data: data
  })
}

// 获取系统角色菜单数据权限数据
export function getSystemRoleDataAuthApi(data) {
  return request({
    url: '/sys/dataAuthority/getRoleAuthoritys',
    method: 'post',
    data
  })
}

// 设置系统角色菜单数据权限数据
export function setSystemRoleDataAuthApi(data) {
  return request({
    url: '/sys/dataAuthority/saveRoleAuthoritys',
    method: 'post',
    data
  })
}

// -------------------
// get设置模块inner权限
export function getRoleModuleAuthApi(data) {
  return request({
    url: '/sys/sysRoleOperation/initRoleOperations',
    method: 'post',
    data
  })
}

// add新增模块inner权限
export function addRoleModuleAuthApi(data) {
  return request({
    url: '/sys/sysRoleOperation/saveOperation',
    method: 'post',
    data
  })
}

// 设置模块权限确认
export function settingModuleAuthApi(data) {
  return request({
    url: '/sys/sysRoleOperation/saveRolesOptions',
    method: 'post',
    data
  })
}
/**
 * 获取角色分配人员列表-菜单引用用弹窗
 * @param data
 */
export function getRoleUsers(data) {
  return request({
    url: '/sys/role/queryUserListByRoleId',
    method: 'post',
    data
  })
}
