import request from '@/utils/request'
/**
 * 获取用户列表
 * @param key
 * @param params
 */
export function getUserlist(data) {
  return request({
    url: '/sys/user/listByCondition',
    method: 'post',
    data
  })
}

/**
 * 获取用户个性化数据 历史。。
 * @param key
 * @param params
 */
export function getUserIviditionData(key, params) {
  return request({
    url: `/sys/individuate/getUserData/${key}`,
    method: 'get',
    params: params || {}
  })
}

/**
 * 刷新用户个性化数据 历史。。
 * @param key
 * @param data
 */
export function addUserIviditionData(key, data) {
  return request({
    url: `/sys/individuate/addUserData/${key}`,
    method: 'post',
    data
  })
}
/**
 * 获取用户个性化数据
 * @param key
 * @param params
 */
export function getUserIvidSettingData(key, params) {
  return request({
    url: `/sys/individuate/getUserSetting/${key}`,
    method: 'get',
    params: params || {}
  })
}

/**
 * 刷新用户个性化数据 历史。。
 * @param key
 * @param data
 */
export function addUserIvidSettingData(key, data) {
  return request({
    url: `/sys/individuate/addUserSetting/${key}`,
    method: 'post',
    data
  })
}
/**
 * 刷新用户个性化数据 历史模糊key。。
 * @param key
 * @param data
 */
export function getUserIvidDataLike(key) {
  return request({
    url: `/sys/individuate/getUserDataLike/${key}`,
    method: 'get',
    params: {}
  })
}
/**
 * 用户管理--添加用户
 * @param data
 */
export function saveAddEditUser(data) {
  return request({
    url: '/sys/user/saveUser',
    method: 'post',
    data: data
  })
}
/**
 * 用户管理--删除用户
 * @param data
 */
export function deleteUser(data) {
  return request({
    url: '/sys/user/deleteById',
    method: 'get',
    params: data
  })
}
/**
 * 用户管理--新增用户获取验证码
 * @param data
 */
export function getUserCaptcha(data) {
  return request({
    url: '/sys/user/captcha',
    method: 'get',
    params: data
  })
}
/**
 *右上角个人信息--修改
 * @param data
 */
export function updatePersonalInfo(data) {
  return request({
    url: '/sys/user/updateUser',
    method: 'post',
    data: data
  })
}

export function getUserDataAuthorityApi(data) {
  return request({
    url: '/sys/userRuleDatas/findUserRuleDatas',
    method: 'post',
    data
  })
}
export function getUserDataAuthInnerApi(data) {
  return request({
    url: '/sys/userRuleDatas/findDatasPage',
    method: 'post',
    data
  })
}

export function saveUserRuleDatasApi(data) {
  return request({
    url: '/sys/userRuleDatas/saveUserRuleDatas',
    method: 'post',
    data
  })
}
// 查询portal用户列表接口
export function getPortalUserList(data) {
  return request({
    url: '/sys/idmUser/selectIdmUsers',
    method: 'post',
    data
  })
}
// 添加portal用户
export function addPortalUsers(data) {
  return request({
    url: '/sys/idmUser/addIdmUserToSys',
    method: 'get',
    params: data
  })
}
// 添加portal用户
export function getMultiRoleUsers(data) {
  return request({
    url: '/sys/user/queryUserbatchByRole',
    method: 'post',
    data: data
  })
}
// 查看用户关联角色
export function getUserRoles(data) {
  return request({
    url: '/sys/role/queryRoleByUserId',
    method: 'post',
    data: data
  })
}
