import useAsync from '@/hooks/useAsync'
import { getRolelist } from '@/api/role'
/**
 * 获取角色列表
 * @param key
 * @param callback
 */
const getUserRolelistApi = (params, callback) => {
  const data = useAsync(async() => {
    const result = await getRolelist(params)
    if (result && result.isSuccess) {
      return result.data
    } else {
      return []
    }
  }, res => {
    if (callback) callback(res)
  })
  return data
}

export {
  getUserRolelistApi
}
