import { ref, /* onMounted, onUnmounted, */ watch } from 'vue'

export function useFilter(parentList) {
  const inputval = ref('')
  const currentList = ref([])

  const filterFunc = (val) => {
    inputval.value = val
    if (!inputval.value) {
      currentList.value = [...parentList]
    } else {
      currentList.value = parentList.filter(obj => obj.name.includes(inputval.value))
    }
  }
  watch(() => [...parentList], (newval, oldval) => {
    currentList.value = [...newval]
  })

  return {
    inputval,
    currentList,
    filterFunc
  }
}
