import ElementPlus from 'element-plus'
import '@/style/element.index.scss'
import '@/style/index.scss'
import 'windi.css'
import * as ElIconModules from '@element-plus/icons'

import { SvgIcon } from '../icons'
import useTable from './useTable'
import HidPanel from './HidPanel'
import HidTable from './HidTable'
import HidPagination from './HidPagination'
import HidRole from './HidRole'
import HidTopBar from './HidTopBar'
import HidContacts from './HidContacts'
import HidNotice from './HidNotice'
import container from './container'

const components = [SvgIcon, HidPanel, HidTable, HidPagination, HidRole, HidTopBar, HidContacts, HidNotice, container]
export function registerGlobComp(app) {
  for (const iconName in ElIconModules) {
    app.component(transElIconName(iconName), ElIconModules[iconName])
  }
  app.use(ElementPlus).use(useTable)
  components.forEach((comp) => {
    app.component(comp.name || comp.displayName, comp)
  })
}
// 将el-icon的组件名称AbbbCddd转化为i-abbb-cddd形式
// 此前用switch做组件名时因关键字重复报错，所以格式统一加了前缀
// 例：Switch转换为i-switch，ArrowDownBold转换为i-arrow-down-bold
function transElIconName(iconName) {
  return 'i' + iconName.replace(/[A-Z]/g, (match) => '-' + match.toLowerCase())
}
