// import type { App } from 'vue';
import 'xe-utils'
import VXETable from 'vxe-table'
import { i18n } from '@/locales/setupI18n'
import 'vxe-table/lib/style.css'

export default function useTable(app) {
  VXETable.setup({
    i18n: (key, args) => i18n.global.t(key, args),
    translate(key, args) {
      return i18n.global.t(key, args)
    }
  })
  app.use(VXETable)

  // 给 vue 实例挂载内部对象，例如：
  // app.config.globalProperties.$XModal = VXETable.modal
  // app.config.globalProperties.$XPrint = VXETable.print
  // app.config.globalProperties.$XSaveFile = VXETable.saveFile
  // app.config.globalProperties.$XReadFile = VXETable.readFile
}
