import { reactive, /* toRefs, */ ref } from 'vue'
const useAsyncFn = (fn, sCallBack) => {
  const data = reactive({ value: {}, loading: false, error: undefined })
  const lastCallId = ref(0)
  const callBack = (...args) => {
    data.loading = true
    const callId = ++lastCallId.value
    fn(...args).then(res => { // res is await return
      if (callId === lastCallId.value) {
        data.value = res
        data.loading = false
      }
      if (sCallBack) sCallBack({ value: res, loading: false, error: undefined })
    }, error => {
      if (callId === lastCallId.value) {
        data.error = error
        data.loading = false
      }
      if (sCallBack) sCallBack(data)
    })
  }

  return [data, callBack]
}

export default useAsyncFn
