let draging = false
let dragDom
let dragpoint
let dragDirection
let dragDiffWidth
function handleMouseUp() {
  draging = false
  dragDom = null
  dragDirection = null
  dragDiffWidth = null
  document.removeEventListener('mousemove', handleMousemove)
}
function handleMousemove(ev) {
  if (draging) {
    const _dragdom = dragDom
    const sty = window.getComputedStyle(_dragdom, null)
    if (dragDirection) {
      if (dragDirection === 'x') {
        let marginR = `${parseFloat(sty.marginRight) - (ev.clientX - dragpoint.x)}`
        if (marginR < 15) {
          marginR = 15
        } else if (marginR > dragDiffWidth) {
          marginR = dragDiffWidth
        }
        _dragdom.style.marginRight = marginR + 'px'
      } else if (dragDirection === 'y') {
        _dragdom.style.marginTop = `${parseFloat(sty.marginTop) + ev.clientY - dragpoint.y}px`
      }
    } else {
      _dragdom.style.marginLeft = `${parseFloat(sty.marginLeft) + ev.clientX - dragpoint.x}px`
      _dragdom.style.marginTop = `${parseFloat(sty.marginTop) + ev.clientY - dragpoint.y}px`
    }
    dragpoint = {
      x: ev.clientX,
      y: ev.clientY
    }
  }
}

function bind(el, direction, diffwidth) {
  const dialogHeaderEl = el.querySelector('.el-dialog__header')
  dialogHeaderEl.addEventListener('mousedown', (ev) => {
    const target = ev.target
    if (target.classList.contains('el-dialog__close')) {
      return
    }
    draging = true
    dragDom = el
    if (direction) dragDirection = direction
    if (diffwidth) dragDiffWidth = diffwidth
    dragpoint = {
      x: ev.clientX,
      y: ev.clientY
    }
    document.addEventListener('mouseup', handleMouseUp)
    document.addEventListener('mousemove', handleMousemove)
  })
}
export default {
  bind
}
