import { ref, onMounted, onUnmounted } from 'vue'

export function useOutVisible(id) {
  const uVisible = ref(false)
  const switchComment = (e) => {
    if (!document.getElementById(id).contains(e.target) && uVisible.value) {
      uVisible.value = false
    }
  }

  onMounted(() => {
    document.addEventListener('click', switchComment)
  })
  onUnmounted(() => {
    document.removeEventListener('click', switchComment)
  })
  return {
    uVisible
  }
}
