import { ref, onMounted, onUnmounted } from 'vue'
import { getTableHeight } from '../utils/index'

export function useResizeHeight(differHeight) {
  const tableheight = ref('400')

  tableheight.value = getTableHeight(differHeight)
  function listenResizeFn() {
    tableheight.value = getTableHeight(differHeight)
  }
  onMounted(() => {
    window.addEventListener('resize', listenResizeFn)
  })

  onUnmounted(() => {
    window.removeEventListener('resize', listenResizeFn)
  })
  return {
    tableheight
  }
}

export function useResizeHeightHalf(differHeight) {
  const tableheight = ref('400')
  const h = Number(getTableHeight(differHeight))
  tableheight.value = (h / 2) + ''
  function listenResizeFn() {
    const h = Number(getTableHeight(differHeight))
    tableheight.value = (h / 2) + ''
  }
  onMounted(() => {
    window.addEventListener('resize', listenResizeFn)
  })
  onUnmounted(() => {
    window.removeEventListener('resize', listenResizeFn)
  })
  return {
    tableheight
  }
}
