import { commonSingleUploadFile, commonBatchUploadFile } from '@/api/common'
import { ElMessage } from 'element-plus'

export const useHidSingleUpload = (file, spaceCode, noMessage) => {
  const formData = new FormData()
  const currentSpaceCode = spaceCode || ''
  formData.append('file', file.raw)
  formData.append('space', currentSpaceCode)
  return new Promise((resolve, reject) => {
    commonSingleUploadFile(formData).then(res => {
      if (!noMessage) {
        ElMessage({
          showClose: true,
          type: 'success',
          message: '上传成功！'
        })
      }
      resolve(res.data)
    }).catch(err => {
      console.log(err)
      reject(err)
    })
  })
}

export const useHidMutipleUpload = (files, spaceCode, noMessage) => {
  const formData = new FormData()
  files.forEach(file => {
    formData.append('files', file.raw)
  })
  formData.append('space', spaceCode || '')
  return new Promise((resolve, reject) => {
    commonBatchUploadFile(formData).then(res => {
      if (!noMessage) {
        ElMessage({
          showClose: true,
          type: 'success',
          message: '上传成功！'
        })
      }
      resolve(res.data)
    }).catch(err => {
      console.log(err)
      reject(err)
    })
  })
}
