import { createI18n } from 'vue-i18n'
import messages from './index'
import store from '@/store'
import { getStore } from '@/utils/store'
import { LOCALE_KEY } from '@/constant/app'
import { setHtmlPageLang } from './helper'
export let i18n
async function createI18nOptions() {
  const locale = store.getters['locale/currentLocale']
  setHtmlPageLang(locale)
  const lang = getStore({ name: LOCALE_KEY })
  if (!lang) {
    store.commit('locale/SET_LOCALE', locale)
  }
  return {
    fallbackLocale: 'zh',
    globalInjection: true,
    legacy: false,
    locale,
    messages,
  }
}
export default async function setupI18n(app) {
  const options = await createI18nOptions()
  i18n = createI18n(options)
  app.use(i18n)
}
