import Cookies from 'js-cookie'

export function getToken(name) {
  if (!Cookies.get(name)) {
    return localStorage.getItem(name)
  }
  return Cookies.get(name)
}

export function setToken(name, token, expires) {
  if (expires) {
    return Cookies.set(name, token, expires)
  } else {
    return Cookies.set(name, token)
  }
}

export function removeToken(name) {
  return Cookies.remove(name)
}
