/* eslint-disable */
//不使用JQuery版的
import html2canvas from 'html2canvas'
import JsPDF from 'jspdf'

/**
 * @param  ele          要生成 pdf 的DOM元素（容器）
 * @param  padfName     PDF文件生成后的文件名字
 * */

function downloadPDF(ele, pdfName) {

  let eleW = ele.offsetWidth// 获得该容器的宽
  let eleH = ele.offsetHeight// 获得该容器的高
  let eleOffsetTop = ele.offsetTop  // 获得该容器到文档顶部的距离
  let eleOffsetLeft = ele.offsetLeft // 获得该容器到文档最左的距离

  var canvas = document.createElement('canvas')
  var abs = 0

  let win_in = document.documentElement.clientWidth || document.body.clientWidth // 获得当前可视窗口的宽度（不包含滚动条）
  let win_out = window.innerWidth // 获得当前窗口的宽度（包含滚动条）

  if (win_out > win_in) {
    // abs = (win_o - win_i)/2;    // 获得滚动条长度的一半
    abs = (win_out - win_in) / 2    // 获得滚动条宽度的一半
    // console.log(a, '新abs');
  }
  canvas.width = eleW * 2    // 将画布宽&&高放大两倍
  canvas.height = eleH * 2

  var context = canvas.getContext('2d')
  context.scale(2, 2)
  context.translate(-eleOffsetLeft - abs, -eleOffsetTop)
  // 这里默认横向没有滚动条的情况，因为offset.left(),有无滚动条的时候存在差值，因此
  // translate的时候，要把这个差值去掉

  // html2canvas(element).then( (canvas)=>{ //报错
  // html2canvas(element[0]).then( (canvas)=>{
  html2canvas(ele, {
    dpi: 300,
    width: 7721, // 有滚动条的时候设置整体宽度使用
    // allowTaint: true,  //允许 canvas 污染， allowTaint参数要去掉，否则是无法通过toDataURL导出canvas数据的
    useCORS: true  //允许canvas画布内 可以跨域请求外部链接图片, 允许跨域请求。
  }).then((canvas) => {
    var contentWidth = canvas.width
    var contentHeight = canvas.height
    //一页pdf显示html页面生成的canvas高度;
    var pageHeight = contentWidth / 592.28 * 841.89
    //未生成pdf的html页面高度
    var leftHeight = contentHeight
    //页面偏移
    var position = 0
    //a4纸的尺寸[595.28,841.89]，html页面生成的canvas在pdf中图片的宽高
    var imgWidth = 595.28
    var imgHeight = 595.28 / contentWidth * contentHeight
    var pageData = canvas.toDataURL('image/jpeg', 1.0)
    var pdf = new JsPDF('', 'pt', 'a4')
    //有两个高度需要区分，一个是html页面的实际高度，和生成pdf的页面高度(841.89)
    //当内容未超过pdf一页显示的范围，无需分页
    if (leftHeight < pageHeight) {
      //在pdf.addImage(pageData, 'JPEG', 左，上，宽度，高度)设置在pdf中显示；
      pdf.addImage(pageData, 'JPEG', 0, 0, imgWidth, imgHeight)
      // pdf.addImage(pageData, 'JPEG', 20, 40, imgWidth, imgHeight);
    } else {    // 分页
      while (leftHeight > 0) {
        pdf.addImage(pageData, 'JPEG', 0, position, imgWidth, imgHeight)
        leftHeight -= pageHeight
        position -= 841.89
        //避免添加空白页
        if (leftHeight > 0) {
          pdf.addPage()
        }
      }
    }
    //可动态生成
    pdf.save(pdfName)
  })
}

function getPdf(){
  var title = '角色管理'  //DPF标题
  html2canvas(document.querySelector('#pdfDom'), {
    allowTaint: true,
    taintTest: false,
    useCORS: true,
    y:72, // 对Y轴进行裁切
    // width:1200,
    // height:5000,
    dpi: window.devicePixelRatio * 4, //将分辨率提高到特定的DPI 提高四倍
    scale: 4 //按比例增加分辨率
  }).then(function (canvas) {
    let contentWidth = canvas.width
    let contentHeight = canvas.height
    let pageHeight = contentWidth / 592.28 * 841.89
    let leftHeight = contentHeight
    let position = 0
    let imgWidth = 595.28
    let imgHeight = 592.28 / contentWidth * contentHeight
    let pageData = canvas.toDataURL('image/jpeg', 1.0)
    let PDF = new JsPDF('', 'pt', 'a4')
    if (leftHeight < pageHeight) {
      PDF.addImage(pageData, 'JPEG', 0, 0, imgWidth, imgHeight)
    } else {
      while (leftHeight > 0) {
        PDF.addImage(pageData, 'JPEG', 0, position, imgWidth, imgHeight)
        leftHeight -= pageHeight
        position -= 841.89
        if (leftHeight > 0) {
          PDF.addPage()
        }
      }
    }
    PDF.save(title + '.pdf')
  }).catch((err)=>{
    debugger
    console.log(err)
  })
}
function print() {
  debugger
  const content = document.getElementById("pdfDom").innerHTML;
  const iframe = document.createElement('IFRAME');//<HTMLInputElement>document.createElement('IFRAME');
  iframe.setAttribute('style', 'position:absolute;width:0px;height:0px;left:-500px;top:-500px;');
  document.body.appendChild(iframe);
  const doc = iframe.contentWindow.document;//(<HTMLIFrameElement> <unknown>iframe).contentWindow.document;
  doc.write(content);
  const ys="ul li {list-style: none;}.print-box {width: 300px;margin: 10px auto;border: 1px #5C5C5C solid;}.print-box-image {width: 150px;height: 200px;margin: 20px auto;}.faceImage {width: 150px;height: 200px;}.information-box {margin: 0;padding: 0;text-align: center;}.list-content-name {font-size: 30px;font-weight: 500;}.print-box-qr {margin-bottom: 10px;text-align: center;}";
  const style=document.createElement("style");
  style.innerText=ys;
  doc.getElementsByTagName("head")[0].appendChild(style)
  doc.close();
  iframe.onload = function(){
/*   (<HTMLIFrameElement> <unknown>iframe).contentWindow.focus();
   (<HTMLIFrameElement> <unknown>iframe).contentWindow.print();*/
   iframe.contentWindow.focus();
   iframe.contentWindow.print();
   };
    return false;
}

export function printOut(id,name) {
  let pdfDom = document.querySelector('#'+id); //这里绑定你要转换的页面
  html2canvas(pdfDom,{
    //开始截图,这里可以设置一些截图时的属性
/*    logging: false,*/
    allowTaint:'true',
    backgroundColor: 'white',
    useCORS: true, //支持图片跨域
    scale: 2, //设置放大的倍数
    height: document.getElementById(id).scrollHeight,
    windowHeight: document.getElementById(id).scrollHeight
    //height:3000,
  }).then((canvas)=>{
    // 开始将图片转换为PDF
    var pdf = new JsPDF("p", "mm", "a4") // A4纸，纵向
    var ctx = canvas.getContext("2d")
    console.log(canvas.height)
    var a4w = 170; var a4h = 257 // A4大小，210mm x 297mm，四边各保留20mm的边距，显示区域170x257
    var imgHeight = Math.floor(a4h * canvas.width / a4w) // 按A4显示比例换算一页图像的像素高度
    var renderedHeight = 0
    while (renderedHeight < canvas.height) {
      var page = document.createElement("canvas")
      page.width = canvas.width
      page.style.zIndex = 999999
      page.style.color = "#000000"
      page.height = Math.min(imgHeight, canvas.height - renderedHeight)// 可能内容不足一页
      // 用getImageData剪裁指定区域，并画到前面创建的canvas对象中
      page.getContext("2d").putImageData(ctx.getImageData(0, renderedHeight, canvas.width, Math.min(imgHeight, canvas.height - renderedHeight)), 0, 0)
      pdf.addImage(page.toDataURL("image/jpeg", 1.0), "JPEG", 10, 10, a4w, Math.min(a4h, a4w * page.height / page.width)) // 添加图像到页面，保留10mm边距
      renderedHeight += imgHeight
      if (renderedHeight < canvas.height) { pdf.addPage() }// 如果后面还有内容，添加一个空页
      // delete page;
    }
    pdf.save(name)
  }).catch((err)=>{
    debugger
    alert(err)
    console.log(err)
  })
}


function exportPDF (){
  const ele= document.getElementById('pdfDom');
  html2canvas(ele, {
    dpi: 96, // 分辨率
    scale: 2, // 设置缩放
    useCORS: true, // 允许canvas画布内 可以跨域请求外部链接图片, 允许跨域请求。,
    // backgroundColor:'#ffffff',这样背景还是黑的
    bgcolor: '#ffffff', // 应该这样写
    logging: false, // 打印日志用的 可以不加默认为false
    height:  document.body.getElementsByTagName("tbody").scrollHeight,
    windowHeight: document.body.getElementsByTagName("tbody").scrollHeight
  }).then((canvas) => {
    const contentWidth = canvas.width;
    const contentHeight = canvas.height;
    // 一页pdf显示html页面生成的canvas高度;
    const pageHeight = (contentWidth / 592.28) * 841.89;
    // 未生成pdf的html页面高度
    let leftHeight = contentHeight;
    // 页面偏移
    let position = 0;
    // a4纸的尺寸[595.28,841.89]，html页面生成的canvas在pdf中图片的宽高
    const imgWidth = 595.28;
    const imgHeight = (595.28 / contentWidth) * contentHeight;
    const ctx = canvas.getContext('2d');
    // 添加水印
    ctx.textAlign = 'center';
    ctx.textBaseline = 'middle';
    ctx.rotate((25 * Math.PI) / 180);
    ctx.font = '20px Microsoft Yahei';
    ctx.fillStyle = 'rgba(184, 184, 184, 0.8)';
/*    for (let i = contentWidth * -1; i < contentWidth; i += 240) {
      for (let j = contentHeight * -1; j < contentHeight; j += 100) {
        // 填充文字，x 间距, y 间距
        ctx.fillText('水印名', i, j);
      }
    }*/
    const pageData = canvas.toDataURL('image/jpeg', 1.0);
    const pdf = new JsPDF('', 'pt', 'a4');
    if (leftHeight < pageHeight) {
      // 在pdf.addImage(pageData, 'JPEG', 左，上，宽度，高度)设置在pdf中显示；
      pdf.addImage(pageData, 'JPEG', 0, 0, imgWidth, imgHeight);
    } else {
      // 分页
      while (leftHeight > 0) {
        pdf.addImage(
          pageData,
          'JPEG',
          0,
          position,
          imgWidth,
          imgHeight
        );
        leftHeight -= pageHeight;
        position -= 841.89;
        // 避免添加空白页
        if (leftHeight > 0) {
          pdf.addPage();
        }
      }
    }
    // 可动态生成
    pdf.save(`文件名.pdf`);
  });
}

export default {
  downloadPDF,
  getPdf,
  print,
  printOut,
  exportPDF

}
