/**
 * Parse the list to string
 * Author: zangxianfeng
 * @returns {string | null}
 */
/* export function formateListToHorizontal(treeList, parentId, treeMap, horizontalTree) {
  treeList.forEach(item => {
    let currentParentId = null
    if (parentId) {
      currentParentId = parentId
    } else {
      currentParentId = null
    }
    const obj = Object.assign({}, {}, item)
    obj.parentId = currentParentId
    treeMap[item.feeCode] = obj
    horizontalTree.push(obj)
    currentParentId = [...currentParentId, item.id]
    // fullPathArr.push(item.id)
    if (item.children) {
      formateListToHorizontal(item.children, currentParentId, treeMap, horizontalTree)
    }
  })
} */

/* export function formateListToHorizontal(treeList, goalMap, goalList, parentFeeCode = null) {
  for (var i = 0; i < treeList.length; i++) {
    const feeCode = treeList[i].feeCode
    goalMap[feeCode] = treeList[i]
    treeList[i].parentFeeCode = parentFeeCode
    goalList.push(treeList[i])
    if (treeList[i].children && treeList[i].children.length > 0) {
      formateListToHorizontal(treeList[i].children, goalMap, goalList, treeList[i].feeCode)
    }
  }
} */
function isNumber(val) {
  if (val && val.constructor.toString().indexOf('Number') > -1) {
    return true
  } else {
    return false
  }
}

export function formateListToCurrentTree(treeList, goalMap) {
  for (var i = 0; i < treeList.length; i++) {
    if (!treeList[i].childrens) {
      treeList[i].childrens = []
    }
    if (treeList[i].childrens && treeList[i].childrens.length > 0) {
      formateListToCurrentTree(treeList[i].childrens, goalMap)
    }
    const docSpaceCode = treeList[i].docSpaceCode
    goalMap[docSpaceCode] = treeList[i]
    if (treeList[i].docs && treeList[i].docs.length > 0) {
      const docs = treeList[i].docs
      for (let j = 0; j < docs.length; j++) {
        const id = docs[j].id
        goalMap[id] = docs[j]
      }
    } else {
      treeList[i].docs = []
    }

    const child = treeList[i].childrens
    const docs = treeList[i].docs
    treeList[i].childrens = [...child, ...docs]
  }
}

export function formateListToCurrentTreeMap(treeList, goalMap) {
  for (var i = 0; i < treeList.length; i++) {
    if (treeList[i].childrens && treeList[i].childrens.length > 0) {
      formateListToCurrentTreeMap(treeList[i].childrens, goalMap)
    }
    const docSpaceCodeCopy = treeList[i].docSpaceCodeCopy
    goalMap[docSpaceCodeCopy] = treeList[i]
  }
}

export function formateDocsToChildrens(treeList) {
  for (var i = 0; i < treeList.length; i++) {
    if (!treeList[i].childrens) {
      treeList[i].childrens = []
    }
    // 只取外层
    /* if (treeList[i].childrens && treeList[i].childrens.length > 0) {
      formateListToCurrentTree(treeList[i].childrens)
    } */
    const child = treeList[i].childrens
    const docs = treeList[i].docs || []
    treeList[i].childrens = [...child, ...docs]
  }
}

export function formateDocsParentCodeToChildrens(treeO) {
  const childs = treeO.childrens || []
  const docs = treeO.docs || []
  childs.forEach(child => {
    child.docSpaceCodeCopy = JSON.parse(JSON.stringify(child.docSpaceCode + ''))
    child.hasChild = true
  })
  if (docs.length > 0) {
    docs.forEach(doc => {
      doc.parentCode = treeO.docSpaceCode
    })
  }
  return [...childs, ...docs]
}

export function fromateFindDeepParentToHorizontal(map, code, arr) {
  if (map[code]) {
    // arr.push(map[code])
    arr.unshift(map[code])
    if (map[code].parentCode) {
      const parentCode = map[code].parentCode
      fromateFindDeepParentToHorizontal(map, parentCode, arr)
    }
  }
}

export function formateDeepChildrenToFirstLevel(chidrenList, arr) {
  for (var i = 0; i < chidrenList.length; i++) {
    arr.push(chidrenList[i])
    if (chidrenList[i].children && chidrenList[i].children.length > 0) {
      formateDeepChildrenToFirstLevel(chidrenList[i].children, arr)
    }
  }
  return arr
}

// 这里格式化了totalValue为两位小数，如果不需要此功能请重写一个不要改这个func了
export function formateListToHorizontal(treeList, goalMap, goalList) {
  for (var i = 0; i < treeList.length; i++) {
    treeList[i].totalValue = isNumber(treeList[i].totalValue) ? treeList[i].totalValue.toFixed(2) : ''
    const feeCode = treeList[i].feeCode
    goalMap[feeCode] = treeList[i]
    // treeList[i].parentFeeCode = parentFeeCode
    goalList.push(treeList[i])
    if (treeList[i].children && treeList[i].children.length > 0) {
      formateListToHorizontal(treeList[i].children, goalMap, goalList)
    }
  }
}

export function formateListToMap(arr, goalMap) {
  for (var i = 0; i < arr.length; i++) {
    const feeCode = arr[i].feeCode
    goalMap[feeCode] = arr[i]
    if (arr[i].children && arr[i].children.length > 0) {
      formateListToMap(arr[i].children, goalMap)
    }
  }
}

/* export function formateFormulaToArray(str) {
  var reg = /\$\{(.+?)\}/
  var reg_g = /(\$\{(.+?)\})|\+|\-|\*|\/|\(|\)/g
  var result = str.match(reg_g)

  var list = []
  for (var i = 0; i < result.length; i++) {
    var item = result[i]
    if (item.indexOf('${') !== -1) {
      list.push(item.match(reg)[1])
    } else {
      if (item === '+') {
        list.push('plus')
      } else if (item === '-') {
        list.push('minus')
      } else if (item === '*') {
        list.push('multiply')
      } else if (item === '/') {
        list.push('division')
      } else if (item === '(') {
        list.push('leftbrackets')
      } else if (item === ')') {
        list.push('rightbrackets')
      }
    }
  }
  return list
} */

export function getDeepListFromMap(treeMap, row, choosedTreeList, parentRowPass) {
  let currentRow
  if (!parentRowPass) {
    currentRow = treeMap[row.id]
  } else {
    currentRow = parentRowPass
  }
  if (currentRow.parentId) {
    /* if (!arr.includes(currentRow.parentId)) {
      arr.push(currentRow.parentId)
    } */
    const parentRow = Object.assign({}, treeMap[currentRow.parentId], {})
    parentRow.children.push(currentRow)
    getDeepListFromMap(treeMap, parentRow, choosedTreeList, parentRow)
  } else {
    if (choosedTreeList.length > 0) {
      const index = choosedTreeList.findIndex(obj => obj.id === currentRow.id)
      if (index !== -1) {
        choosedTreeList.splice(index, 1, currentRow)
      } else {
        choosedTreeList.push(currentRow)
      }
    } else {
      choosedTreeList.push(currentRow)
    }
  }
}
/**
 * 构造树型结构数据
 * @param {*} data 数据源
 * @param {*} id id字段 默认 'id'
 * @param {*} parentId 父节点字段 默认 'parentId'
 * @param {*} children 孩子节点字段 默认 'children'
 */
export function handleTree(data, id, parentId, children) {
  const config = {
    id: id || 'id',
    parentId: parentId || 'parentId',
    childrenList: children || 'children'
  }

  var childrenListMap = {}
  var nodeIds = {}
  var tree = []

  for (const d of data) {
    const parentId = d[config.parentId]
    if (childrenListMap[parentId] == null) {
      childrenListMap[parentId] = []
    }
    nodeIds[d[config.id]] = d
    childrenListMap[parentId].push(d)
  }

  for (const d of data) {
    const parentId = d[config.parentId]
    if (nodeIds[parentId] == null) {
      tree.push(d)
    }
  }

  for (const t of tree) {
    adaptToChildrenList(t)
  }

  function adaptToChildrenList(o) {
    if (childrenListMap[o[config.id]] !== null) {
      o[config.childrenList] = childrenListMap[o[config.id]]
    }
    if (o[config.childrenList] && o[config.childrenList].length > 0) {
      for (const c of o[config.childrenList]) {
        adaptToChildrenList(c)
      }
    }
  }
  return tree
}

export function formateTreeToHorizontal(treeList, goalList = []) {
  for (var i = 0; i < treeList.length; i++) {
    goalList.push(treeList[i])
    formateTreeToHorizontal(treeList[i].children, goalList)
  }
  return goalList
}
