import { getUserIviditionData } from '@/api/user'
import { reactive } from 'vue'
import store from '@/store'
import useAsync from '@/hooks/useAsync'
const initUserData = (params, callback) => {
  /**
   * 初始化项目显示
   * */
  const localData = store.getters['app/curRightSelectObj']
  if (localData.length === 0) {
    params.type = 'project'
    useAsync(async() => {
      const ret = await getUserIviditionData('user_project_history', params)
      if (ret && ret.isSuccess) {
        const recentList = ret.data.list
        if (recentList.length > 0) {
          let oneD = null
          if (params.type === 'project') {
            oneD = { type: 'project', key: 'drawerProjects', row: reactive(recentList[0]), value: false }
          } else if (params.type === 'portfolio') {
            oneD = { type: 'portfolio', key: 'drawerProtfolio', row: reactive(recentList[0]), value: false }
          }
          store.commit('app/SET_CURRIGHTSELECTOBJ', oneD)
        }
      }
    }, res => {
      if (callback) callback(res)
    })
  }
}
export {
  initUserData
}
